<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
   
   <meta name="description" content="FLUBIO - An unstructured, parallel, finite volume Navier-Stokes solver for teaching and research purposes">
    
    <meta name="author" content="Edoardo Alinovi and Joel Guerrero" >
    <link rel="icon" href="../favicon.png">

    <title>noesc &ndash; FLUBIO</title>

    <link href="../css/bootstrap.min.css" rel="stylesheet">
    <link href="../css/pygments.css" rel="stylesheet">
    <link href="../css/font-awesome.min.css" rel="stylesheet">
    <link href="../css/local.css" rel="stylesheet">
    
    <link  href="../tipuesearch/tipuesearch.css" rel="stylesheet">
    
    

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
    
    <script src="../js/jquery-2.1.3.min.js"></script>
    <script src="../js/svg-pan-zoom.min.js"></script>

  </head>

  <body>

    <!-- Fixed navbar -->
    <nav class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="../index.html">FLUBIO </a>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
          <ul class="nav navbar-nav">
        
            <li class="dropdown hidden-xs visible-sm visible-md hidden-lg">
              <a href="#" class="dropdown-toggle"
              data-toggle="dropdown" role="button"
              aria-haspopup="true"
     aria-expanded="false">Contents <span class="caret"></span></a>
        <ul class="dropdown-menu">
          
              
            <li><a href="../lists/files.html">Source Files</a></li>
        
        
        
            <li><a href="../lists/modules.html">Modules</a></li>
        
            
                                
            <li><a href="../lists/procedures.html">Procedures</a></li>
        
               
            <li><a href="../lists/types.html">Derived Types</a></li>
        
        
            <li><a href="../lists/programs.html">Programs</a></li>
               
        
        
            </ul>
        
            </li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/files.html">Source Files</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/modules.html">Modules</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/procedures.html">Procedures</a></li>

                             
<li class="visible-xs hidden-sm visible-lg"><a href="../lists/types.html">Derived Types</a></li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/programs.html">Programs</a></li>



          </ul>
        
        <form action="../search.html" class="navbar-form navbar-right" role="search">
        <div class="form-group">
          <input type="text" class="form-control" placeholder="Search" name="q" id="tipue_search_input" autocomplete="off" required>
        </div>
<!--
        <button type="submit" class="btn btn-default">Submit</button>
-->
        </form>
        
        </div><!--/.nav-collapse -->
      </div>
    </nav>

    <div class="container">
    
  
  <div class="row">
    <h1>noesc
      <small>Function</small>
    
    </h1>
    
<div class="row">
  <div class="col-lg-12">
<div class="well well-sm">
  <ul class="list-inline" style="margin-bottom:0px;display:inline">
     
     
     
    <li><i class="fa fa-legal"></i> <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a></li> 
     
     
     
    
    
     <li><i class="fa fa-list-ol"></i>
       <a data-toggle="tooltip"
    data-placement="bottom" data-html="true"
    title=" 0.1% of total for procedures.">15 statements</a>
     </li> 
     
     
     
    <li><i class="fa fa-code"></i><a href="../src/mstrings.f03"> Source File</a></li>
     
     
  </ul>
  <ol class="breadcrumb in-well text-right">
  
    
     <li><a href='../sourcefile/mstrings.f03.html'>mstrings.f03</a></li>
    
     <li><a href='../module/m_strings.html'>M_strings</a></li>
    
  
     <li class="active">noesc</li>
  </ol>
</div>
</div>
</div>
<script>
  $(function () {
  $('[data-toggle="tooltip"]').tooltip()
  })
</script>

  </div>
  
  <div class="row">
    <div class="col-md-3 hidden-xs hidden-sm visible-md visible-lg">
    
<div id="sidebar">
  
<h3>Contents</h3>
 





















<em>None</em>


</div>

    </div>
    
    <div class="col-md-9" id='text'>
    <h2>
public elemental function noesc(INSTR)
    
    
   
</h2>
    
  


    
    <h2>NAME</h2>
<div class="codehilite"><pre><span></span><code> noesc(3f) - [M_strings:NONALPHA] convert non-printable characters to a space.
</code></pre></div>

<h2>SYNOPSIS</h2>
<div class="codehilite"><pre><span></span><code>elemental function noesc(INSTR)

 character(len=*),intent(in) :: INSTR
 character(len=len(instr))   :: noesc
</code></pre></div>

<h2>DESCRIPTION</h2>
<div class="codehilite"><pre><span></span><code>  Convert non-printable characters to a space.
</code></pre></div>

<h2>EXAMPLES</h2>
<p>Sample Program:</p>
<div class="codehilite"><pre><span></span><code><span class="n">program</span> <span class="n">demo_noesc</span>

 <span class="n">use</span> <span class="n">M_strings</span><span class="p">,</span> <span class="n">only</span> <span class="p">:</span> <span class="n">noesc</span>
 <span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="o">=</span><span class="mi">128</span><span class="p">)</span> <span class="p">::</span> <span class="n">ascii</span>
 <span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="o">=</span><span class="mi">128</span><span class="p">)</span> <span class="p">::</span> <span class="n">cleared</span>
 <span class="o">!</span> <span class="n">fill</span> <span class="n">variable</span> <span class="n">with</span> <span class="n">base</span> <span class="n">ASCII</span> <span class="n">character</span> <span class="n">set</span>
 <span class="n">do</span> <span class="n">i</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span><span class="mi">128</span>
    <span class="n">ascii</span><span class="p">(</span><span class="n">i</span><span class="p">:</span><span class="n">i</span><span class="p">)</span><span class="o">=</span><span class="nb">char</span><span class="p">(</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span>
 <span class="n">enddo</span>
 <span class="n">cleared</span><span class="o">=</span><span class="n">noesc</span><span class="p">(</span><span class="n">ascii</span><span class="p">)</span>
 <span class="n">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="o">*</span><span class="p">)</span><span class="s1">&#39;characters and their ADE (ASCII Decimal Equivalent)&#39;</span>
 <span class="n">call</span> <span class="n">ade</span><span class="p">(</span><span class="n">ascii</span><span class="p">)</span>
 <span class="n">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="o">*</span><span class="p">)</span><span class="s1">&#39;Cleared of non-printable characters&#39;</span>
 <span class="n">call</span> <span class="n">ade</span><span class="p">(</span><span class="n">cleared</span><span class="p">)</span>
 <span class="n">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="o">*</span><span class="p">)</span><span class="s1">&#39;Cleared string:&#39;</span>
 <span class="n">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="o">*</span><span class="p">)</span><span class="n">cleared</span>
 <span class="n">contains</span>
   <span class="n">subroutine</span> <span class="n">ade</span><span class="p">(</span><span class="n">string</span><span class="p">)</span>
   <span class="n">implicit</span> <span class="n">none</span>
   <span class="o">!</span> <span class="n">the</span> <span class="n">string</span> <span class="n">to</span> <span class="nb">print</span>
   <span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="o">=*</span><span class="p">),</span><span class="n">intent</span><span class="p">(</span><span class="ow">in</span><span class="p">)</span> <span class="p">::</span> <span class="n">string</span>
   <span class="o">!</span> <span class="n">number</span> <span class="n">of</span> <span class="n">characters</span> <span class="ow">in</span> <span class="n">string</span> <span class="n">to</span> <span class="nb">print</span>
   <span class="n">integer</span> <span class="p">::</span> <span class="n">ilen</span>
   <span class="o">!</span> <span class="n">counter</span> <span class="n">used</span> <span class="n">to</span> <span class="n">step</span> <span class="n">thru</span> <span class="n">string</span>
   <span class="n">integer</span> <span class="p">::</span> <span class="n">i</span>
      <span class="o">!</span> <span class="n">get</span> <span class="n">trimmed</span> <span class="n">length</span> <span class="n">of</span> <span class="n">input</span> <span class="n">string</span>
      <span class="n">ilen</span><span class="o">=</span><span class="n">len_trim</span><span class="p">(</span><span class="n">string</span><span class="p">(:</span><span class="n">len</span><span class="p">(</span><span class="n">string</span><span class="p">)))</span>

      <span class="o">!</span> <span class="n">replace</span> <span class="n">lower</span> <span class="n">unprintable</span> <span class="n">characters</span> <span class="n">with</span> <span class="n">spaces</span>
      <span class="n">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="mi">101</span><span class="p">)(</span><span class="n">merge</span><span class="p">(</span><span class="n">string</span><span class="p">(</span><span class="n">i</span><span class="p">:</span><span class="n">i</span><span class="p">),</span><span class="s1">&#39; &#39;</span><span class="p">,</span><span class="o">&amp;</span>
      <span class="o">&amp;</span> <span class="n">ichar</span><span class="p">(</span><span class="n">string</span><span class="p">(</span><span class="n">i</span><span class="p">:</span><span class="n">i</span><span class="p">))</span><span class="o">.</span><span class="n">ge</span><span class="o">.</span><span class="mi">32</span>         <span class="o">&amp;</span>
      <span class="o">&amp;</span> <span class="o">.</span><span class="ow">and</span><span class="o">.</span>                            <span class="o">&amp;</span>
      <span class="o">&amp;</span> <span class="n">ichar</span><span class="p">(</span><span class="n">string</span><span class="p">(</span><span class="n">i</span><span class="p">:</span><span class="n">i</span><span class="p">))</span><span class="o">.</span><span class="n">le</span><span class="o">.</span><span class="mi">126</span><span class="p">)</span>       <span class="o">&amp;</span>
      <span class="o">&amp;</span> <span class="p">,</span><span class="n">i</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span><span class="n">ilen</span><span class="p">)</span>

      <span class="o">!</span> <span class="nb">print</span> <span class="n">ADE</span> <span class="n">value</span> <span class="n">of</span> <span class="n">character</span> <span class="n">underneath</span> <span class="n">it</span>
      <span class="n">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="mi">202</span><span class="p">)</span>     <span class="p">(</span><span class="n">ichar</span><span class="p">(</span><span class="n">string</span><span class="p">(</span><span class="n">i</span><span class="p">:</span><span class="n">i</span><span class="p">))</span><span class="o">/</span><span class="mi">100</span><span class="p">,</span>    <span class="n">i</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span><span class="n">ilen</span><span class="p">)</span>
      <span class="n">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="mi">202</span><span class="p">)(</span><span class="n">mod</span><span class="p">(</span> <span class="n">ichar</span><span class="p">(</span><span class="n">string</span><span class="p">(</span><span class="n">i</span><span class="p">:</span><span class="n">i</span><span class="p">)),</span><span class="mi">100</span><span class="p">)</span><span class="o">/</span><span class="mi">10</span><span class="p">,</span><span class="n">i</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span><span class="n">ilen</span><span class="p">)</span>
      <span class="n">write</span><span class="p">(</span><span class="o">*</span><span class="p">,</span><span class="mi">202</span><span class="p">)(</span><span class="n">mod</span><span class="p">((</span><span class="n">ichar</span><span class="p">(</span><span class="n">string</span><span class="p">(</span><span class="n">i</span><span class="p">:</span><span class="n">i</span><span class="p">))),</span><span class="mi">10</span><span class="p">),</span>   <span class="n">i</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span><span class="n">ilen</span><span class="p">)</span>
   <span class="o">!</span> <span class="n">format</span> <span class="k">for</span> <span class="n">printing</span> <span class="n">string</span> <span class="n">characters</span>
   <span class="mi">101</span>   <span class="n">format</span><span class="p">(</span><span class="o">*</span><span class="p">(</span><span class="n">a1</span><span class="p">:))</span>
   <span class="o">!</span> <span class="n">format</span> <span class="k">for</span> <span class="n">printing</span> <span class="n">ADE</span> <span class="n">values</span>
   <span class="mi">202</span>   <span class="n">format</span><span class="p">(</span><span class="o">*</span><span class="p">(</span><span class="n">i1</span><span class="p">:))</span>
   <span class="n">end</span> <span class="n">subroutine</span> <span class="n">ade</span>
 <span class="n">end</span> <span class="n">program</span> <span class="n">demo_noesc</span>

<span class="n">Expected</span> <span class="n">output</span>

<span class="n">The</span> <span class="n">string</span> <span class="k">is</span> <span class="n">printed</span> <span class="n">with</span> <span class="n">the</span> <span class="n">ADE</span> <span class="n">value</span> <span class="n">vertically</span> <span class="n">beneath</span><span class="o">.</span>
<span class="n">The</span> <span class="n">original</span> <span class="n">string</span> <span class="n">has</span> <span class="n">all</span> <span class="n">the</span> <span class="n">ADEs</span> <span class="n">from</span> <span class="mi">000</span> <span class="n">to</span> <span class="mf">127.</span> <span class="n">After</span>
<span class="n">NOESC</span><span class="p">(</span><span class="mi">3</span><span class="n">f</span><span class="p">)</span> <span class="k">is</span> <span class="n">called</span> <span class="n">on</span> <span class="n">the</span> <span class="n">string</span> <span class="n">all</span> <span class="n">the</span> <span class="s2">&quot;non-printable&quot;</span>
<span class="n">characters</span> <span class="n">are</span> <span class="n">replaced</span> <span class="n">with</span> <span class="n">a</span> <span class="n">space</span> <span class="p">(</span><span class="n">ADE</span> <span class="n">of</span> <span class="mi">032</span><span class="p">)</span><span class="o">.</span>
</code></pre></div>

<p>characters and their ADE (ASCII Decimal Equivalent)</p>
<div class="codehilite"><pre><span></span><code><span class="o">&gt;</span><span class="w">                                 </span><span class="err">!&quot;#$</span><span class="o">%&amp;</span><span class="err">&#39;</span><span class="p">()</span><span class="o">*+</span><span class="p">,</span><span class="o">-</span><span class="p">.</span><span class="o">/</span><span class="mi">0123456789</span><span class="err">:</span><span class="p">;</span><span class="o">&lt;=&gt;</span><span class="vm">?</span><span class="nv">@ABCDEFGHIJKLMNOPQRSTUVWXYZ</span><span class="o">[</span><span class="n">\</span><span class="o">]^</span><span class="n">_</span><span class="err">`</span><span class="n">abcdefghijklmnopqrstuvwxyz</span><span class="err">{</span><span class="o">|</span><span class="err">}</span><span class="o">~</span><span class="w"></span>
<span class="o">&gt;</span><span class="mi">00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000001111111111111111111111111111</span><span class="w"></span>
<span class="o">&gt;</span><span class="mi">00000000001111111111222222222233333333334444444444555555555566666666667777777777888888888899999999990000000000111111111122222222</span><span class="w"></span>
<span class="o">&gt;</span><span class="mi">01234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567</span><span class="w"></span>
</code></pre></div>

<p>Cleared of non-printable characters</p>
<div class="codehilite"><pre><span></span><code><span class="o">&gt;</span><span class="w">                                 </span><span class="err">!&quot;#$</span><span class="o">%&amp;</span><span class="err">&#39;</span><span class="p">()</span><span class="o">*+</span><span class="p">,</span><span class="o">-</span><span class="p">.</span><span class="o">/</span><span class="mi">0123456789</span><span class="err">:</span><span class="p">;</span><span class="o">&lt;=&gt;</span><span class="vm">?</span><span class="nv">@ABCDEFGHIJKLMNOPQRSTUVWXYZ</span><span class="o">[</span><span class="n">\</span><span class="o">]^</span><span class="n">_</span><span class="err">`</span><span class="n">abcdefghijklmnopqrstuvwxyz</span><span class="err">{</span><span class="o">|</span><span class="err">}</span><span class="o">~</span><span class="w"></span>
<span class="o">&gt;</span><span class="mi">0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000111111111111111111111111111</span><span class="w"></span>
<span class="o">&gt;</span><span class="mi">3333333333333333333333333333333333333333444444444455555555556666666666777777777788888888889999999999000000000011111111112222222</span><span class="w"></span>
<span class="o">&gt;</span><span class="mi">2222222222222222222222222222222223456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456</span><span class="w"></span>
</code></pre></div>

<p>Cleared string:
    &gt;                                  !"#$%&amp;'()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_`abcdefghijklmnopqrstuvwxyz{|}~</p>
    

    <h3>Arguments</h3>
    
      
<table class="table table-striped varlist">
<thead><tr><th>Type</th>
<th>Intent</th><th>Optional</th>
<th>Attributes</th><th></th><th>Name</th><th></th></thead>



<tbody>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-instr"></span>character(len=*),</td>
  <td>intent(in)</td>
  <td></td>
  
  <td></td><td>::</td>
  <td><strong>INSTR</strong></td><td></td>
  
</tr>

</tbody>
</table>

    
    
    
    
    
    
    
   <h3>Return Value <small><span class="anchor" id="variable-noesc"></span>character(len=len)
  </small></h3>
    
    
    
    
     
    <br>

    <section class="visible-xs visible-sm hidden-md">
      
<h3>Contents</h3>
 





















<em>None</em>


    </section>
    <br class="visible-xs visible-sm hidden-md">

    

    
    
    
    
    

    
    
    
    
    


    
    
    
    
    </div>
  </div>


    <hr>    
    </div> <!-- /container -->
    <footer>
      <div class="container">
      <div class="row">
        <div class="col-xs-6 col-md-6"><p>FLUBIO was developed by Edoardo Alinovi and Joel Guerrero<br>&copy; 2021 <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a>
                                          </p>
        </div>
        <div class="col-xs-6 col-md-6">
          <p class="text-right">
            Documentation generated by 
            <a href="https://github.com/Fortran-FOSS-Programmers/ford">FORD</a>
            
            
          </p>
        </div>
      </div>
      <br>
      </div> <!-- /container -->    
    </footer>

    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
<!--
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
-->
    <script src="../js/bootstrap.min.js"></script>
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <script src="../js/ie10-viewport-bug-workaround.js"></script>

    <!-- MathJax JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script type="text/x-mathjax-config">
      MathJax.Hub.Config({
        TeX: { extensions: ['AMSmath.js','AMSsymbols.js','noErrors.js','noUndefined.js'], equationNumbers: { autoNumber: 'AMS' } },
        jax: ['input/TeX','input/MathML','output/HTML-CSS'],
        extensions: ['tex2jax.js','mml2jax.js','MathMenu.js','MathZoom.js']
      });
    </script>
    
    <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    
    
    <script src="../tipuesearch/tipuesearch_content.js"></script>
    <script src="../tipuesearch/tipuesearch_set.js"></script>
    <script src="../tipuesearch/tipuesearch.js"></script>
    
    
  </body>
</html>